<!DOCTYPE html>
<html >
	<body>
		<h2>Add Expense</h2>
		<form >
			<table >
				<tr>
					<td>Date:</td>
					<td><input type="date" name="dateTxt"></td>
				</tr>
				<tr>
					<td>Amount:</td>
					<td><input type="number" name="amtTxt"></td>
				</tr>
				<tr>
					<td>Description</td>
					<td><input type="text" name="descTxt"></td>
				</tr>
				<tr>
					<td colspan="2">
						<button type="button" name="addBtn">Add</button>
					</td>
				</tr>
			</table>
		</form>
		
		<h2>Expenses:</h2>
		<table name="expList">
			<tr>
				<th>Date</th>
				<th>Amount</th>
				<th>Description</th>
			</tr>
		</table>
	</body>
</html>

<script >
	document.getElementsByName("addBtn").item(0).onclick = function(){
		addExpense();
	}
</script>

<cfclient>
	<cfset variables.dsn = "expenseDS">
	
	<cfquery datasource="#variables.dsn#">
		create table if not exists expense (
			id integer primary key,
			expense_date integer,
			amt real,
			desc text
		)
	</cfquery>
	
	<cfset listExpenses()>
	
	<cffunction name="listExpenses" >
		<cfquery datasource="#variables.dsn#" name="rs">
			select * from expense order by expense_date desc
		</cfquery>
		
		<cfloop query="rs">
			<cfset var tmpDate = new Date(expense_date)>
			<cfset addExpenseRow(expense_date,amt,desc)>
		</cfloop>
	</cffunction>
	
	<cffunction name="addExpenseRow" >
		<cfargument name="expense_date" >
		<cfargument name="amt" >
		<cfargument name="desc" >
		
		<cfoutput >
			<cfsavecontent variable="rowHtml" >
				<tr>
					<td>#dateFormat(expense_date,"mm/dd/yyyy")#</td>
					<td>#amt#</td>
					<td>#desc#</td>
				</tr>
			</cfsavecontent>
		</cfoutput>
		
		<cfset document.getElementsByName("expList").item(0).innerHTML += rowHtml>
	</cffunction>
	
	<cffunction name="addExpense" >
		<cfset var tmpDate = new Date(document.getElementsByName("dateTxt").item(0).value)>
		<cfset var amt = Number(document.getElementsByName("amtTxt").item(0).value)>
		<cfset var desc = document.getElementsByName("descTxt").item(0).value>
		
		<cfquery datasource="#variables.dsn#">
			insert into expense (expense_date,amt,desc) values(
				<cfqueryparam cfsqltype="cf_sql_date" value="#tmpDate.getTime()#">,
				<cfqueryparam cfsqltype="cf_sql_numeric" value="#amt#">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#desc#">
			)
		</cfquery>
		
		<cfset addExpenseRow(tmpDate,amt,desc)>
		
	</cffunction>
</cfclient>